local scheduleUpdate = true
local maxResponseTime = settings.global["dynamic-construction-queue-max-response-time"]["value"]
local trackTiles = settings.global["dynamic-construction-queue-track-tiles"]["value"]

script.on_init(function()
    local IDs= {}
    local g = 0
    local args = {type="entity-ghost"}
    for k, v in pairs(game.surfaces) do 
        print("processing surface" .. k)
        for key, ghost in pairs(v.find_entities_filtered(args)) do
            IDs[script.register_on_entity_destroyed(ghost)] = true
            g = g + 1
        end
    end
    --print("found ghosts: " .. g)
    global.ghosts = g
    global.registrationIDs = IDs
end)

script.on_event(defines.events.on_built_entity, function(event)
    if event.created_entity.type == "entity-ghost" or (event.created_entity.type == "tile-ghost" and trackTiles) then 
        global.ghosts = global.ghosts + 1
        scheduleUpdate = true
        global.registrationIDs[script.register_on_entity_destroyed(event.created_entity)] = true
    end
end)

script.on_event(defines.events.on_entity_destroyed, function(event)
    if global.registrationIDs[event.registration_number] then
        global.ghosts = global.ghosts - 1
        scheduleUpdate = true
        global.registrationIDs[event.registration_number] = nil
    end
end)

script.on_event(defines.events.script_raised_built, function(event)
    if event.entity.type == "entity-ghost" then 
        global.ghosts = global.ghosts + 1
        scheduleUpdate = true
        global.registrationIDs[script.register_on_entity_destroyed(event.created_entity)] = true
    end
end)

script.on_event(defines.events.on_post_entity_died, function(event)
    if event.ghost ~= nil then 
        global.ghosts = global.ghosts + 1
        scheduleUpdate = true
        global.registrationIDs[script.register_on_entity_destroyed(event.ghost)] = true
    end
end)

local function updateConstructionQueueRefresh()
    -- calculate the new update rate
    local updateRate = math.floor(global.ghosts/(maxResponseTime*60))
    --print("queue updateRate set to " .. updateRate .. " for " .. global.ghosts .. " ghosts")
    game.forces["player"].max_successful_attempts_per_tick_per_construction_queue = math.max(updateRate,3)
	game.forces["player"].max_failed_attempts_per_tick_per_construction_queue = math.max(updateRate,1)
end

script.on_nth_tick(60, function(event)
    if (scheduleUpdate) then
        updateConstructionQueueRefresh()
        scheduleUpdate = false
    end
end)